//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXAppBar.h
 * @brief		AvP[Vo[NXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_WXAppBar_H_
#define INCG_IRIS_WXAppBar_H_

//======================================================================
// include
#include "iris_object.h"

#if	defined(IRIS_WIN32_WCE)
#error not support.
#endif

namespace iris {
namespace wx
{

//======================================================================
// class
//! AvP[Vo[NX
class CAppBar : public IIrisObject
{
protected:
	mutable APPBARDATA	m_Data;	//!< AvP[Vo[
public:
	// RXgN^
	CAppBar(void);
	// fXgN^
	~CAppBar(void);

public:
	// 쐬
	BOOL		Create(HWND hWnd, UINT uCallbackMessage, UINT uEdge, LPARAM lParam=0);
	// 폜
	UINT_PTR	Destroy(void);

public:
	// bZ[WM
	UINT_PTR	Message(DWORD dwMessage) const;

public:
	/// Ԏ擾
	UINT_PTR	GetState(void) const;
	/// activate
	UINT_PTR	Activate(BOOL activate);

public:
	/**
	 * @name	f[^擾
	 * @{
	*/
			APPBARDATA&	GetData(void)			{ return m_Data; }
	const	APPBARDATA&	GetData(void)	const	{ return m_Data; }
	/**
	 * @}
	*/

};

}	// end of namespace wx
}	// end of namespace iris

#endif
